#define SUPPORT_VALENCIA
inline void IO_InitValencia(void)
{
	gotype_current.id                 = GOTYPE_VALENCIA;
	gotype_current.caseid             = GOCASE_VALENCIA;
	gotype_current.name               = "TomTom GO 710 or 910";
	gotype_current.usbname            = "GO 710 or 910";
	gotype_current.familyname         = "TomTom GO";
	gotype_current.projectname        = "VALENCIA";
	gotype_current.btname             = gotype_current.name;
	gotype_current.requiredbootloader = "4.23";
	gotype_current.cputype            = GOCPU_S3C2442;

	gotype_current.btdev              = "ttySAC1";
	gotype_current.btchip             = GOBT_BC4;
	gotype_current.btspeed            = 921600;
	gotype_current.btclock            = 16000000;
	gotype_current.btclass            = 0x280408; // STK: changed "rendering" to "capturing" for A2DP
	gotype_current.handsfree          = 1;
	gotype_current.headsetgw          = 1; // STK: changed to 1 to support Bristol
	gotype_current.a2dp               = 1;

	gotype_current.chargertype        = GOCHARGER_LTC1733;
	gotype_current.sdcard             = 1;
	gotype_current.harddisk           = 1;
	gotype_current.tfttype            = GOTFT_SAMSUNG_LTP400;
	gotype_current.tsxchannel         = 5;
	gotype_current.tsychannel         = 7;

	gotype_current.gpsdev             = "ttySAC2";
	gotype_current.gpstype            = GOGPS_SIRF3;
	gotype_current.codectype          = GOCODEC_WM8971;
	gotype_current.usbslavetype       = GOUSB_NET2272;
	gotype_current.memsize            = 64;
	gotype_current.harddisktiming     = 4;
	gotype_current.ohciports          = 0x02;
	gotype_current.regulatorforcodec  = 1;
	gotype_current.rxddetect          = 1; /* pulldown on RXD0 to aid uart0 detect */
	gotype_current.pulldowns          = 1;
	gotype_current.codecmaster        = 1;
	gotype_current.backlightfreq      = 30000;
	gotype_current.keeprtcpowered     = 1;
	gotype_current.pnp                = 1;

#ifdef VALENCIA_PCB_REV20
	gotype_current.pins.SD_PWR_ON        = PIN_GPG2 | PIN_INVERTED;
	gotype_current.pins.SDCLK            = PIN_GPE5;
	gotype_current.pins.SDCMD            = PIN_GPE6;
	gotype_current.pins.SDDATA0          = PIN_GPE7;
	gotype_current.pins.SDDATA1          = PIN_GPE8;
	gotype_current.pins.SDDATA2          = PIN_GPE9;
	gotype_current.pins.SDDATA3          = PIN_GPE10;
	gotype_current.pins.WP_SD            = PIN_GPH8;
	gotype_current.pins.CD_SD            = PIN_GPF2  | PIN_INVERTED;
	gotype_current.pins.GPS_RESET        = PIN_GPH0 | PIN_INVERTED;
	gotype_current.pins.GPS_ON           = PIN_GPJ6;
	gotype_current.pins.GPS_1PPS         = PIN_GPG0;
	gotype_current.pins.GPS_REPRO        = PIN_GPJ11;
	gotype_current.pins.HDD_LED          = PIN_GPJ5 | PIN_INVERTED;
	gotype_current.pins.HDD_PWR_ON       = PIN_GPB7 | PIN_INVERTED;
	gotype_current.pins.HDD_RST          = PIN_GPG3 | PIN_INVERTED;
	gotype_current.pins.HDD_BUF_EN       = PIN_GPA15 | PIN_INVERTED;
	gotype_current.pins.HDD_IRQ          = PIN_GPG11;
	gotype_current.pins.CHARGEFAULT      = PIN_GPJ0 | PIN_INVERTED;
	gotype_current.pins.CHARGE_OUT       = PIN_GPJ7 | PIN_OPEN_EMITTER;
	gotype_current.pins.CHARGING         = PIN_GPJ12 | PIN_INVERTED;
	gotype_current.pins.AIN4_PWR         = PIN_GPA13;
	gotype_current.pins.DOCK_PWREN       = PIN_GPJ9 | PIN_INVERTED;
	gotype_current.pins.TXD_DOCK         = PIN_GPH2;
	gotype_current.pins.RXD_DOCK         = PIN_GPH3 | PIN_PULLDOWN;
	gotype_current.pins.DOCK_SENSE       = PIN_GPJ8 | PIN_INVERTED;
	gotype_current.pins.DOCK_DESK_SENSE  = PIN_GPJ10 | PIN_INVERTED;
	gotype_current.pins.USB_HOST_DETECT  = PIN_GPF3 | PIN_INVERTED;
	gotype_current.pins.EXTMIC_DETECT    = PIN_GPF3 | PIN_INVERTED;
	gotype_current.pins.HEADPHONE_DETECT = PIN_GPF4 | PIN_INVERTED;
	gotype_current.pins.FSK_IRQ          = PIN_GPG8 | PIN_INVERTED;
	gotype_current.pins.SPICLK           = PIN_GPE13;
	gotype_current.pins.SPIMSI           = PIN_GPE12;
	gotype_current.pins.SPIMSO           = PIN_GPE11;
	gotype_current.pins.FSK_EN           = PIN_GPJ2;
	gotype_current.pins.FSK_FFS          = PIN_GPG6;
	gotype_current.pins.ACC_PWR_ON       = PIN_GPJ4 | PIN_INVERTED;
	gotype_current.pins.HW_IIC_SCL       = PIN_GPE14;
	gotype_current.pins.HW_IIC_SDA       = PIN_GPE15;
	gotype_current.pins.GYRO_EN          = PIN_GPF5;
	gotype_current.pins.MUTE_INT         = PIN_GPJ3;
	gotype_current.pins.DAC_PWR_ON       = PIN_GPG7;
	gotype_current.pins.MUTE_EXT         = PIN_GPH1;
	gotype_current.pins.I2SSDO           = PIN_GPE4;
	gotype_current.pins.CDCLK            = PIN_GPE2;
	gotype_current.pins.CDCLK_12MHZ      = PIN_GPH10;
	gotype_current.pins.I2SSCLK          = PIN_GPE1;
	gotype_current.pins.I2SLRCK          = PIN_GPE0;
	gotype_current.pins.I2SSDI           = PIN_GPE3;
	gotype_current.pins.L3CLOCK          = PIN_GPB4;
	gotype_current.pins.L3MODE           = PIN_GPB3;
	gotype_current.pins.L3DATA           = PIN_GPB2;
	gotype_current.pins.TXD_GPS          = PIN_GPH6;
	gotype_current.pins.RXD_GPS          = PIN_GPH7;
	gotype_current.pins.TXD_BT           = PIN_GPH4;
	gotype_current.pins.RXD_BT           = PIN_GPH5;
	gotype_current.pins.RTS_BT           = PIN_GPG9;
	gotype_current.pins.CTS_BT           = PIN_GPG10;
	gotype_current.pins.BT_RESET         = PIN_GPF1 | PIN_INVERTED;
	gotype_current.pins.BT_MODE          = PIN_GPB1;
	gotype_current.pins.BT_CLKOUT        = PIN_GPH9; /* not used */
	gotype_current.pins.VD0              = PIN_GPC8;
	gotype_current.pins.VD1              = PIN_GPC9;
	gotype_current.pins.VD2              = PIN_GPC10;
	gotype_current.pins.VD3              = PIN_GPC11;
	gotype_current.pins.VD4              = PIN_GPC12;
	gotype_current.pins.VD5              = PIN_GPC13;
	gotype_current.pins.VD6              = PIN_GPC14;
	gotype_current.pins.VD7              = PIN_GPC15;
	gotype_current.pins.VD8              = PIN_GPD0;
	gotype_current.pins.VD9              = PIN_GPD1;
	gotype_current.pins.VD10             = PIN_GPD2;
	gotype_current.pins.VD11             = PIN_GPD3;
	gotype_current.pins.VD12             = PIN_GPD4;
	gotype_current.pins.VD13             = PIN_GPD5;
	gotype_current.pins.VD14             = PIN_GPD6;
	gotype_current.pins.VD15             = PIN_GPD7;
	gotype_current.pins.VD16             = PIN_GPD8;
	gotype_current.pins.VD17             = PIN_GPD9;
	gotype_current.pins.VD18             = PIN_GPD10;
	gotype_current.pins.VD19             = PIN_GPD11;
	gotype_current.pins.VD20             = PIN_GPD12;
	gotype_current.pins.VD21             = PIN_GPD13;
	gotype_current.pins.VD22             = PIN_GPD14;
	gotype_current.pins.VD23             = PIN_GPD15;
	gotype_current.pins.VDEN             = PIN_GPC4;
	gotype_current.pins.VCLK             = PIN_GPC1;
	gotype_current.pins.VSYNC            = PIN_GPC3;
	gotype_current.pins.HSYNC            = PIN_GPC2;
	gotype_current.pins.LCD_VCC_PWREN    = PIN_GPG4 | PIN_INVERTED;
	gotype_current.pins.LCD_BIAS_PWREN   = PIN_GPC6;
	gotype_current.pins.LCD_RESET        = PIN_GPC7 | PIN_INVERTED;
	gotype_current.pins.BACKLIGHT_PWM    = PIN_GPB0;
	gotype_current.pins.USB_DACK         = PIN_GPB9;
	gotype_current.pins.USB_DREQ         = PIN_GPB10;
	gotype_current.pins.USB_IRQ          = PIN_GPG5 | PIN_INVERTED;
	gotype_current.pins.USB_VBUS         = PIN_GPJ1;
	gotype_current.pins.USB_RESET        = PIN_GPA18 | PIN_INVERTED;
	gotype_current.pins.ON_OFF           = PIN_GPF0 | PIN_INVERTED;
	gotype_current.pins.ACPWR            = PIN_GPG1 | PIN_INVERTED;
	gotype_current.pins.IGNITION         = PIN_GPG1 | PIN_INVERTED;;
	gotype_current.pins.XMON             = PIN_GPG13 | PIN_OPEN_COLLECTOR;
	gotype_current.pins.XPON             = PIN_GPG12 | PIN_OPEN_EMITTER;
	gotype_current.pins.YMON             = PIN_GPG15 | PIN_OPEN_COLLECTOR;
	gotype_current.pins.YPON             = PIN_GPG14 | PIN_OPEN_EMITTER;
	gotype_current.pins.TSDOWN           = PIN_GPG15 | PIN_OPEN_COLLECTOR;
	gotype_current.pins.LOW_CORE         = PIN_GPB8;
	gotype_current.pins.FLEX_ID1         = PIN_GPF6 | PIN_INVERTED;
	gotype_current.pins.FLEX_ID2         = PIN_GPF7 | PIN_INVERTED;
	gotype_current.pins.LX_EN            = PIN_GPC5;
#else
	gotype_current.pins.SD_PWR_ON        = PIN_GPG2 | PIN_INVERTED;
	gotype_current.pins.SDCLK            = PIN_GPE5;
	gotype_current.pins.SDCMD            = PIN_GPE6;
	gotype_current.pins.SDDATA0          = PIN_GPE7;
	gotype_current.pins.SDDATA1          = PIN_GPE8;
	gotype_current.pins.SDDATA2          = PIN_GPE9;
	gotype_current.pins.SDDATA3          = PIN_GPE10;
	gotype_current.pins.WP_SD            = PIN_GPH8;
	gotype_current.pins.CD_SD            = PIN_GPF2  | PIN_INVERTED;
	gotype_current.pins.GPS_RESET        = PIN_GPJ10 | PIN_INVERTED;
	gotype_current.pins.GPS_ON           = PIN_GPJ6;
	gotype_current.pins.GPS_1PPS         = PIN_GPG0;
	gotype_current.pins.GPS_REPRO        = PIN_GPJ11 | PIN_PULLDOWN;
	gotype_current.pins.HDD_LED          = PIN_GPJ5 | PIN_INVERTED;
	gotype_current.pins.HDD_PWR_ON       = PIN_GPB7 | PIN_INVERTED;
	gotype_current.pins.HDD_RST          = PIN_GPG3 | PIN_INVERTED;
	gotype_current.pins.HDD_BUF_EN       = PIN_GPA15 | PIN_INVERTED;
	gotype_current.pins.HDD_IRQ          = PIN_GPG11;
	gotype_current.pins.HDD_CS           = PIN_GPA14 | PIN_INVERTED;
	gotype_current.pins.CHARGEFAULT      = PIN_GPJ0 | PIN_INVERTED;
	gotype_current.pins.CHARGE_OUT       = PIN_GPJ7 | PIN_OPEN_EMITTER;
	gotype_current.pins.CHARGING         = PIN_GPJ12 | PIN_INVERTED;
	gotype_current.pins.AIN4_PWR         = PIN_GPA13;
	gotype_current.pins.DOCK_PWREN       = PIN_GPJ9 | PIN_INVERTED;
	gotype_current.pins.DOCK_INT         = PIN_GPF3 | PIN_INVERTED;
	gotype_current.pins.SW_SCL           = PIN_GPH0;
	gotype_current.pins.SW_SDA           = PIN_GPH1;
	gotype_current.pins.DOCK_PWREN       = PIN_GPJ9 | PIN_INVERTED;
	gotype_current.pins.FSK_IRQ          = PIN_GPG8 | PIN_INVERTED;
	gotype_current.pins.SPICLK           = PIN_GPE13;
	gotype_current.pins.SPIMSI           = PIN_GPE12;
	gotype_current.pins.SPIMSO           = PIN_GPE11;
	gotype_current.pins.FSK_EN           = PIN_GPJ2;
	gotype_current.pins.FSK_FFS          = PIN_GPG6;
	gotype_current.pins.MIC_SW           = PIN_GPJ8;
	gotype_current.pins.AMP_ON           = PIN_GPJ3;
	gotype_current.pins.DAC_PWR_ON       = PIN_GPG7;
	gotype_current.pins.I2SSDO           = PIN_GPE4;
	gotype_current.pins.CDCLK            = PIN_GPE2;
	gotype_current.pins.CDCLK_12MHZ      = PIN_GPH10;
	gotype_current.pins.I2SSCLK          = PIN_GPE1;
	gotype_current.pins.I2SLRCK          = PIN_GPE0;
	gotype_current.pins.I2SSDI           = PIN_GPE3;
	gotype_current.pins.L3CLOCK          = PIN_GPB4;
	gotype_current.pins.L3MODE           = PIN_GPB3;
	gotype_current.pins.L3DATA           = PIN_GPB2;
	gotype_current.pins.TXD_DOCK         = PIN_GPH2 | PIN_PULLDOWN;
	gotype_current.pins.RXD_DOCK         = PIN_GPH3 | PIN_PULLDOWN;
	gotype_current.pins.RXD_DOCK_INT     = PIN_GPF4 | PIN_PULLDOWN;
	gotype_current.pins.TXD_GPS          = PIN_GPH6;
	gotype_current.pins.RXD_GPS          = PIN_GPH7;
	gotype_current.pins.TXD_BT           = PIN_GPH4;
	gotype_current.pins.RXD_BT           = PIN_GPH5;
	gotype_current.pins.RTS_BT           = PIN_GPG9;
	gotype_current.pins.CTS_BT           = PIN_GPG10;
	gotype_current.pins.BT_RESET         = PIN_GPF1 | PIN_INVERTED;
	gotype_current.pins.BT_MODE          = PIN_GPB1;
	gotype_current.pins.BT_CLKOUT        = PIN_GPH9; /* not used */
	gotype_current.pins.VD0              = PIN_GPC8;
	gotype_current.pins.VD1              = PIN_GPC9;
	gotype_current.pins.VD2              = PIN_GPC10;
	gotype_current.pins.VD3              = PIN_GPC11;
	gotype_current.pins.VD4              = PIN_GPC12;
	gotype_current.pins.VD5              = PIN_GPC13;
	gotype_current.pins.VD6              = PIN_GPC14;
	gotype_current.pins.VD7              = PIN_GPC15;
	gotype_current.pins.VD8              = PIN_GPD0;
	gotype_current.pins.VD9              = PIN_GPD1;
	gotype_current.pins.VD10             = PIN_GPD2;
	gotype_current.pins.VD11             = PIN_GPD3;
	gotype_current.pins.VD12             = PIN_GPD4;
	gotype_current.pins.VD13             = PIN_GPD5;
	gotype_current.pins.VD14             = PIN_GPD6;
	gotype_current.pins.VD15             = PIN_GPD7;
	gotype_current.pins.VD16             = PIN_GPD8;
	gotype_current.pins.VD17             = PIN_GPD9;
	gotype_current.pins.VD18             = PIN_GPD10;
	gotype_current.pins.VD19             = PIN_GPD11;
	gotype_current.pins.VD20             = PIN_GPD12;
	gotype_current.pins.VD21             = PIN_GPD13;
	gotype_current.pins.VD22             = PIN_GPD14;
	gotype_current.pins.VD23             = PIN_GPD15;
	gotype_current.pins.VDEN             = PIN_GPC4;
	gotype_current.pins.VCLK             = PIN_GPC1;
	gotype_current.pins.VSYNC            = PIN_GPC3;
	gotype_current.pins.HSYNC            = PIN_GPC2;
	gotype_current.pins.LCD_VCC_PWREN    = PIN_GPG4 | PIN_INVERTED;
	gotype_current.pins.LCD_BIAS_PWREN   = PIN_GPC6;
	gotype_current.pins.LCD_RESET        = PIN_GPC7 | PIN_INVERTED;
	gotype_current.pins.BACKLIGHT_PWM    = PIN_GPB0;
	gotype_current.pins.USB_DACK         = PIN_GPB9;
	gotype_current.pins.USB_DREQ         = PIN_GPB10;
	gotype_current.pins.USB_IRQ          = PIN_GPG5 | PIN_INVERTED;
	gotype_current.pins.USB_VBUS         = PIN_GPJ1;
	gotype_current.pins.USB_RESET        = PIN_GPA18 | PIN_INVERTED;
	gotype_current.pins.ON_OFF           = PIN_GPF0 | PIN_INVERTED;
	gotype_current.pins.ACPWR            = PIN_GPG1 | PIN_INVERTED;
	gotype_current.pins.IGNITION         = PIN_GPG1 | PIN_INVERTED;
	gotype_current.pins.XMON             = PIN_GPG13 | PIN_OPEN_COLLECTOR;
	gotype_current.pins.XPON             = PIN_GPG12 | PIN_OPEN_EMITTER;
	gotype_current.pins.YMON             = PIN_GPG15 | PIN_OPEN_COLLECTOR;
	gotype_current.pins.YPON             = PIN_GPG14 | PIN_OPEN_EMITTER;
	gotype_current.pins.TSDOWN           = PIN_GPG15 | PIN_OPEN_COLLECTOR;
	gotype_current.pins.LOW_CORE         = PIN_GPB8;
	gotype_current.pins.FLEX_ID1         = PIN_GPF6 | PIN_INVERTED;
	gotype_current.pins.FLEX_ID2         = PIN_GPF7 | PIN_INVERTED;
	gotype_current.pins.LX_EN            = PIN_GPC5;

	// Pins of IO expander in Valencia dock
	gotype_current.pins.DOCK_CRIB_SENSE  = PIN_GPIIC0 | PIN_INVERTED;
	gotype_current.pins.MUTE_EXT         = PIN_GPIIC2;
	gotype_current.pins.HEADPHONE_DETECT = PIN_GPIIC3 | PIN_INVERTED;
	gotype_current.pins.LINEIN_DETECT    = PIN_GPIIC4 | PIN_INVERTED;
	gotype_current.pins.EXTMIC_DETECT    = PIN_GPIIC5 | PIN_INVERTED;
	gotype_current.pins.LIGHTS_DETECT    = PIN_GPIIC6 | PIN_INVERTED;
	gotype_current.pins.TMC_POWER        = PIN_GPIIC7 | PIN_INVERTED;

	// These "pins" will be simulated in software to make life easier
	gotype_current.pins.USB_HOST_DETECT  = PIN_GPIIC8;
	gotype_current.pins.DOCK_SENSE       = PIN_GPIIC9;
	gotype_current.pins.DOCK_DESK_SENSE  = PIN_GPIIC10;	
	gotype_current.pins.DOCK_VIB_SENSE   = PIN_GPIIC11;
#endif
}

inline void IO_InitValencia500(void)
{
	gotype_current.id                 = GOTYPE_VALENCIA500;
	gotype_current.name               = "TomTom GO 710";
	gotype_current.usbname            = "GO 710";
	gotype_current.btname             = "TomTom GO";
	gotype_current.sdcard             = 1;
	gotype_current.harddisk           = 0;
}

inline void IO_InitValencia700(void)
{
	gotype_current.id                 = GOTYPE_VALENCIA700;
	gotype_current.name               = "TomTom GO 910";
	gotype_current.usbname            = "GO 910";
	gotype_current.btname             = gotype_current.name;
	gotype_current.sdcard             = 0;
	gotype_current.harddisk           = 1;
	gotype_current.loquendo           = 1;
	gotype_current.mp3		  = 1;
}
